#	$Id$
# -*- coding: latin-1 -*-
## ********************************************************************************
## 
## Copyright (C) 2006, 2007 Grard Deneux mardi 8 mai 2007, 19:11:31 (UTC+0200)
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    import uno, unohelper
    from com.sun.star.task import XJob
    import traceback
    from com.sun.star.awt import XMouseMotionListener, XKeyHandler, XMouseClickHandler
except ImportError:
    print "probleme d'import"
#===================================
# a class to test listener
# une classe pour tester un listener
#===================================
class CompJob(unohelper.Base, XJob, XMouseMotionListener, XKeyHandler, XMouseClickHandler):
    """Test de listener
    Test of listener"""
    def __init__(self, ctx):
        self.ctx = ctx
        self.smgr = self.ctx.ServiceManager
        # get the central desktop object
        self.desktop = self.smgr.createInstanceWithContext( "com.sun.star.frame.Desktop",self.ctx)
    ## *********************
    ## Other init stuffs
    ## *********************
    def execute(self, aArgs):
        # access the current draw document
        if self.desktop.ActiveFrame.ActiveFrame:
            self.COMPONENTWINDOW = self.desktop.ActiveFrame.ActiveFrame.ComponentWindow
            self.CONTROLLER = self.desktop.ActiveFrame.ActiveFrame.Controller
        else:
            self.COMPONENTWINDOW = self.desktop.ActiveFrame.ComponentWindow
            self.CONTROLLER = self.desktop.ActiveFrame.Controller
        self.CONTROLLER.addKeyHandler(self)
        self.COMPONENTWINDOW.addMouseMotionListener(self)
        self.CONTROLLER.addMouseClickHandler(self)
        return aArgs
    #*********************
    # test of mouse motion
    #*********************
    def mouseMoved(self, aMouseEvent):
        print "mouse motion"
        return
    # **********************************
    def mouseDragged(self, aMouseEvent):
        print "mouse dragged"
        return
    # **********************************
    def mousePressed(self, aMouseEvent):
        print "mouse pressed"
        return True
    # **********************************
    def mouseReleased(self, aMouseEvent):
        print "mouse released"
        return True
    # **********************************
    def keyPressed(self, aKeyEvent):
        print "key pressed"
        return True
    # **********************************
    def keyReleased(self, aKeyEvent):
        print "key released, bye !"
        self.CONTROLLER.removeKeyHandler(self)
        self.COMPONENTWINDOW.removeMouseMotionListener(self)
        self.CONTROLLER.removeMouseClickHandler(self)
        return True
    # XEventListener 
    def disposing(self, eventObject):
        return
# pythonloader looks for a static g_ImplementationHelper variable
g_ImplementationHelper = unohelper.ImplementationHelper()

g_ImplementationHelper.addImplementation(CompJob,                                 # UNO object class
                                         "org.openoffice.comp.pyuno.deneux.CompJob", # implemenation name
                                         ("org.openoffice.comp.pyuno.CompJob",),)    # list of implemented services
