# 	$Id$
# -*- coding: latin-1 -*-
## ********************************************************************************
## testjob.py mardi 8 mai 2007, 19:05:00 (UTC+0200)
## Copyright (C) 2007 Grard Deneux
## gerard.deneux@free.fr

## This library is free software; you can redistribute it and/or
## modify it under the terms of the GNU Lesser General Public
## License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.

## This library is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
## Lesser General Public License for more details.
## http://www.opensource.org/licenses/lgpl-license.php

## You should have received a copy of the GNU Lesser General Public
## License along with this library; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
## ******************************************************************************
try:
    import uno, unohelper
    from com.sun.star.task import XJobExecutor
    import traceback
except ImportError:
    print "probleme d'import"
#=======================
# a class to test 
# une classe pour tester
#=======================
class TestJob(unohelper.Base, XJobExecutor):
    """Test un composant
    test of component"""
    def __init__(self, ctx):
        self.ctx = ctx
        self.smgr = self.ctx.ServiceManager
    #=======================
    # Called by the GUI
    #=======================
    def trigger(self, args):
        aNamedValues = (uno.createUnoStruct("com.sun.star.beans.NamedValue"),)
        aNamedValues[0].Name = "CONTEXT"
        try:
            aCompJob = self.smgr.createInstanceWithContext("org.openoffice.comp.pyuno.CompJob", self.ctx)
            aNamedValues[0].Value = "Command from menu"
            aNamedValues = aCompJob.execute(aNamedValues)
        except:
            traceback.print_exc()
        return
# pythonloader looks for a static g_ImplementationHelper variable
g_ImplementationHelper = unohelper.ImplementationHelper()

g_ImplementationHelper.addImplementation(TestJob,                                 # UNO object class
                                         "org.openoffice.comp.pyuno.deneux.TestJob", # implemenation name
                                         ("org.openoffice.comp.pyuno.TestJob",),)    # list of implemented services
